-------------------------------------------------------------------------------
--|> STATUS BAR
--: Manages the messages in the StatusBar frame
-------------------------------------------------------------------------------
--|> UPVALUE GLOBALS
-------------------------------------------------------------------------------
local weizPVP = weizPVP
local PixelUtil = PixelUtil
-------------------------------------------------------------------------------

--|> FUNCTIONS
-------------------------------------------------------------------------------
local textFadeIn
local textSlideIn
local textFadeOut
local textSlideOut
local inDuration = 0.2

function weizPVP:CreateStatusBar()
	--> StatusFlash
	weizPVP.StatusBar.Text:ClearAllPoints()
	PixelUtil.SetPoint(weizPVP.StatusBar.Text, "TOPLEFT", weizPVP.StatusBar, "BOTTOMLEFT", 0, 0)
	PixelUtil.SetPoint(weizPVP.StatusBar.Text, "TOPRIGHT", weizPVP.StatusBar, "BOTTOMRIGHT", 0, 0)
	-----------------------------------------------------------------------
	--=> AnimationGroup: Fade Text
	-----------------------------------------------------------------------
	weizPVP.StatusBar.Text.anim = weizPVP.StatusBar.Text:CreateAnimationGroup()
	textFadeIn = weizPVP.StatusBar.Text.anim:CreateAnimation("Alpha")
	textFadeIn:SetDuration(inDuration)
	textFadeIn:SetFromAlpha(0)
	textFadeIn:SetToAlpha(1)
	textFadeIn:SetEndDelay(3) --> Set the number of seconds the animation delays after finishing.
	textFadeIn:SetOrder(1)
	textSlideIn = weizPVP.StatusBar.Text.anim:CreateAnimation("Translation")
	textSlideIn:SetDuration(inDuration)
	textSlideIn:SetOffset(0, 13)
	textSlideIn:SetEndDelay(3) --> Set the number of seconds the animation delays after finishing.
	textSlideIn:SetOrder(1)
	textFadeOut = weizPVP.StatusBar.Text.anim:CreateAnimation("Alpha")
	textFadeOut:SetDuration(0.3)
	textFadeOut:SetFromAlpha(1)
	textFadeOut:SetToAlpha(0)
	textFadeOut:SetOrder(2)
	textSlideOut = weizPVP.StatusBar.Text.anim:CreateAnimation("Translation")
	textSlideOut:SetDuration(0.3)
	textSlideOut:SetOffset(0, -13)
	textSlideOut:SetOrder(2)
end

--=> Set Status Bar Message
function weizPVP:SetStatusBarMessage(stringSB, fadeEN, duration, debug)
	if debug then
		weizPVP.StatusBar.Text:SetText("> |cffff3838DEBUG MODE ACTIVE|r <")
		weizPVP.StatusBar.Text:SetAlpha(1)
		weizPVP.StatusBar.Text:Show()
	else
		weizPVP.StatusBar.Text:SetText(" " .. stringSB)
		if fadeEN then
			weizPVP.StatusBar.Text.anim:Stop()
			weizPVP.StatusBar.Text:SetAlpha(1)
			textFadeIn:SetEndDelay(duration)
			textFadeOut:SetToAlpha(0)
			weizPVP.StatusBar.Text.anim:SetScript(
				"OnFinished",
				function()
					weizPVP.StatusBar.Text:SetAlpha(0)
				end
			)
		else
			textFadeOut:SetToAlpha(1)
			weizPVP.StatusBar.Text.anim:SetScript(
				"OnFinished",
				function()
					weizPVP.StatusBar.Text:SetAlpha(1)
				end
			)
		end
		weizPVP.StatusBar.Text.anim:Play()
	end
end
